﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
/*Add this line to use WordWriter:*/
using SoftArtisans.OfficeWriter.WordWriter;

namespace HelloWorld.WordWriter
{
    public partial class WordTemplate_HelloWorld : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            ErrorLabel.Visible = false;
        }

        protected void RunHelloWorld_Click(object sender, EventArgs e)
        {
            try                                    
            {
                //Instantiate the WordTemplate object
                WordTemplate WT = new WordTemplate();

                //Open the template file (templates/template.docx)
                WT.Open(Page.MapPath("templates\\template.docx"));

                //Get the data from the textbox
                string value = DataValueBox.Text.Trim();

                //Use SetDataSource to bind the textbox value to the template:
                 //SetDataSource binds a single row of data, the merge fields can span the entire document
                //This means that we need to create a single-row data set

                //Put the value in an object array
                //Create a string array for the single column name "Variable"
                object[] values = { value };
                string[] columnNames = { "Variable" };

                //Bind the data with SetDataSource
                WT.SetDataSource(values, columnNames);

                //Call Process() to import the data into the document
                WT.Process();

                //Stream the output back to the user as an attachment
                WT.Save(Response, "Output.docx", false);

            }
            catch (Exception ex)
            {
                ErrorLabel.Visible = true;
                if (ex.Message.Contains("General license key exception"))
                {
                    ErrorLabel.Text = "OfficeWriter does not appear to be" +
                       " installed on this machine. If you have not " +
                       "purchased OfficeWriter, you can download the " +
                       "evaluation version here: " +
                       "http://www.officewriter.com/officewriter-free-evaluation.aspx";
                }
                else
                {
                    ErrorLabel.Text = ex.Message;
                }

            }

        }
    }
}
